//========================================================================
//	MShellBuilder.h
//	Copyright 1996 - 97 Metrowerks Corporation, All Rights Reserved.
//========================================================================	

#ifndef _MSHELLBUILDER_H
#define _MSHELLBUILDER_H

#include "MPlugInBuilder.h"
#include "MShellPlugInView.h"

class MShellBuilder : public MPlugInBuilder
{
#if 0
								MShellBuilder()
									{}
	virtual						MShellBuilder()
									{}
#endif

	virtual long				GetToolName(
									char* 		outName,
									long		inBufferLength,
									MakeStageT	inStage,
									MakeActionT	inAction);

	virtual const char *		LinkerName();
	virtual MakeStageT			MakeStages();
	virtual MakeActionT			Actions();
	virtual PlugInFlagsT		Flags();
	virtual ulong				MessageDataType();

	// return true if something changed in the settings
	virtual bool				ValidateSettings(
									BMessage&	inOutMessage);

	virtual long				BuildPrecompileArgv(
									BList& 		inArgv,
									MFileRec& 	inFileRec);

	virtual long				BuildCompileArgv(
									BList& 		inArgv,
									MakeActionT inAction,
									MFileRec& 	inFileRec);

	virtual long				BuildPostLinkArgv(
									BList& 		inArgv,
									MFileRec& 	inFileRec);

	virtual bool				FileIsDirty(
									MFileRec& 	inFileRec,
									MakeStageT	inStage,
									MakeActionT	inAction,
									time_t		inModDate);

	virtual long				ParseMessageText(
									const char*	inText,
									BList&		outList);
	virtual void				CodeDataSize(
									const char* inFilePath,
									long&	outCodeSize,
									long&	outDataSize);
	virtual long				GenerateDependencies(
									const char* inFilePath,
									BList&		outList);
	virtual void				GetTargetFilePaths(
									MFileRec& 	inFileRec,
									BList&		inOutTargetFileList);

	virtual void				ProjectChanged(
									ChangeT		inChange,
									MProject*	inProject);

private:
	
	MProject*			fProject;
	ShellPrefs			fShellPrefs;

	long						BuildArgv(
									BList& 		inArgv,
									const char* inFilePath);
	long						FindEndOfLine(
									const char*	inText,
									long		inOffset);
	void						MessageToPrefs();
};

#endif
